// Con Clase Agosto 2023
// Ejemplo de generacin de cdigo QR
// Salvador Pozo
// Nota: si en la consola se usa el texto blanco sobre fondo negro
// el cdigo estar invertido y el cdigo no ser lejible.
// Se puede corregir esto de varios modos:
// - Intercambiar los espacios y los dots (aunque habra que aadir
//   dots extras alrededor del cdigo.
// - Modificar los colores asignados a las propiedades de la consola.
// - La ms sencilla, seleccionar el texto de la consola, que invierte
//   los colores.

#include <iostream>
#include "qrcodegen.h"

using namespace std;

int main() {
    char *dot="\333\333";
    char *esp="  ";

    // Text data
    uint8_t qr0[qrcodegen_BUFFER_LEN_MAX];
    uint8_t tempBuffer[qrcodegen_BUFFER_LEN_MAX];
    bool ok = qrcodegen_encodeText("https://conclase.net",
        tempBuffer, qr0, qrcodegen_Ecc_MEDIUM,
        qrcodegen_VERSION_MIN, qrcodegen_VERSION_MAX,
        qrcodegen_Mask_AUTO, true);

    if (!ok) return 1;

    int size = qrcodegen_getSize(qr0);
    for (int y = 0; y < size; y++) {
        for (int x = 0; x < size; x++) {
            if(qrcodegen_getModule(qr0, x, y)) {
                cout << dot;
            } else {
                cout << esp;
            }
        }
        cout << endl;
    }

    return 0;
}
